// Do not remove the include below
// #include <HardwareSerial.h>

#include "NetMeterBusMaster2.h"

#include "cmd.h"
#include "test.h"
#include "uptime.h"
// #include "meterBusServer.h"
#include "meterBusMaster.h"
#include "overCurrentProt.h"
#include <Ethernet.h>
#include "MqttClient.h"


const uint8_t POWER_LED = 4;
const uint8_t ETHERNET_RESET = 14;


static uint8_t mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xEF };

static CmdServer cmdServer(2000);
static TestCmd testCmd;
static Uptime uptime;

static MeterBusMaster meterBusMaster;
static MqttClient mqttClient(&meterBusMaster);
// static MeterBusServer meterBusServer(2001, &meterBusMaster);
static OverCurrentProt overCurrentProt;


void setup() {
  Serial.begin(115200);
  delay(100);
  Serial.println("Starting up ...");

  pinMode(POWER_LED, OUTPUT);
  digitalWrite(POWER_LED, LOW);

  pinMode(ETHERNET_RESET, OUTPUT);
  digitalWrite(ETHERNET_RESET, LOW);
  delay(100);
  digitalWrite(ETHERNET_RESET, HIGH);
  delay(100);
  Ethernet.begin(mac);
  Serial.println("Ethernet started");

  cmdServer.begin();
  testCmd.registerYourself(&cmdServer);
  uptime.begin(&cmdServer);

  overCurrentProt.begin(&cmdServer);
  meterBusMaster.begin(&cmdServer);
  // meterBusServer.begin();
  mqttClient.begin();

  digitalWrite(POWER_LED, HIGH);
}

void loop() {
  cmdServer.exec();
  uptime.exec();

  overCurrentProt.exec();
  meterBusMaster.exec();
  // meterBusServer.exec();
  mqttClient.exec();
}
